import com.nttdocomo.ui.IApplication;
import com.nttdocomo.ui.Canvas;
import com.nttdocomo.ui.Graphics;
import com.nttdocomo.ui.Frame;
import com.nttdocomo.ui.Display;


public class NPLoader extends IApplication {

    public void start() {
        Display.setCurrent((Frame)(new MainCanvas()));
    }

}

class MainCanvas extends Canvas {

    MainCanvas() {
        String savedstate = IApplication.getCurrentApp().getParameter("savedstate");
        int savedstateInt = 0;
        try {
            if (savedstate != null)
                savedstateInt = Integer.parseInt(savedstate);
        } catch (Exception e) {
            savedstateInt = 0;
        }
        if (savedstateInt > 0) {
            String args[] = new String[3];
            args[0] = IApplication.getCurrentApp().getSourceURL() + "NemulatorPlus.jam";
            args[1] = "savedstate";
            args[2] = savedstate;
            IApplication.getCurrentApp().launch(IApplication.LAUNCH_IAPPLI, args);
        } else {
            String url[] = new String[1];
            url[0] = IApplication.getCurrentApp().getSourceURL() + "NemulatorPlus.jam";
            IApplication.getCurrentApp().launch(IApplication.LAUNCH_IAPPLI, url);
        }
    }

    public void paint(Graphics g) {
    }
}

