public final class Mapper066 extends Mapper {

    public Mapper066(NESCore nes) {
        super(nes);
    }

    /////////////////////////////////////////////////////////////////////
    // Mapper 66 
    // hS{[_̓	
    public final void Reset() {
          // set CPU bank pointers
          set_CPU_banks(0,1,2,3);
          set_PPU_banks(0,1,2,3,4,5,6,7);

        /*
        if(nes.crc == 0xe30552db) // Paris-Dakar Rally Special {
            nes.frame_irq_disenabled = 1;
        }
        */
    }
    public final void MemoryWriteSaveRAM(int addr, int data) {
        int chr_bank = (data & 0x0F) << 3;
        int prg_bank = (data & 0xF0) >> 2;

        set_CPU_bank4(prg_bank + 0);
        set_CPU_bank5(prg_bank + 1);
        set_CPU_bank6(prg_bank + 2);
        set_CPU_bank7(prg_bank + 3);

        set_PPU_bank0(chr_bank + 0);
        set_PPU_bank1(chr_bank + 1);
        set_PPU_bank2(chr_bank + 2);
        set_PPU_bank3(chr_bank + 3);
        set_PPU_bank4(chr_bank + 4);
        set_PPU_bank5(chr_bank + 5);
        set_PPU_bank6(chr_bank + 6);
        set_PPU_bank7(chr_bank + 7);
    }

    public final void MemoryWrite(int addr, int data) {
        int chr_bank = (data & 0x0F) << 3;
        int prg_bank = (data & 0xF0) >> 2;

        set_CPU_bank4(prg_bank + 0);
        set_CPU_bank5(prg_bank + 1);
        set_CPU_bank6(prg_bank + 2);
        set_CPU_bank7(prg_bank + 3);

        set_PPU_bank0(chr_bank + 0);
        set_PPU_bank1(chr_bank + 1);
        set_PPU_bank2(chr_bank + 2);
        set_PPU_bank3(chr_bank + 3);
        set_PPU_bank4(chr_bank + 4);
        set_PPU_bank5(chr_bank + 5);
        set_PPU_bank6(chr_bank + 6);
        set_PPU_bank7(chr_bank + 7);
    }
}
