import com.nttdocomo.ui.Font;
import com.nttdocomo.ui.Graphics;
import com.nttdocomo.ui.Image;

public class Disp240x320 implements Disp{
	private final NESCanvas gui;
	private final NESCore core;
	private Image img = null;
	private Image BaseImg = null;
	private Image BaseImg2 = null;
	private Image StrImg = null;
	private Graphics imgG = null;
	private Graphics BaseImgG = null;
	private Graphics BaseImg2G = null;
	private Graphics StrImgG = null;
	private int w;
	private int h;

	private final int HEIGHT_LINE;
	private final int BASE_LINE;

	{
		HEIGHT_LINE = Font.getDefaultFont().getHeight() + (1 + 2 * 2);
		BASE_LINE = 3 + Font.getDefaultFont().getAscent();
	}

	Disp240x320(NESCanvas _gui, NESCore _core){
		gui = _gui;
		core = _core;
		img = gui.fb2;

		BaseImg = Image.createImage(gui.getHeight(), gui.getWidth());
		BaseImgG = BaseImg.getGraphics();
		BaseImg2 = Image.createImage(gui.getWidth(), gui.getHeight());
		BaseImg2G = BaseImg2.getGraphics();

		StrImg = Image.createImage(gui.getHeight(), 16);
		StrImgG = StrImg.getGraphics();
		StrImgG.setFont(Font.getDefaultFont());

	}

	public void init(){
		w = gui.width;
		h = gui.height;
	}

	public void vrt(Graphics g, String messageStr, int fpsDisp){
		g.setFlipMode(Graphics.FLIP_NONE);
		// w  h ͉Ȃ̂ŋtɂȂB킩ɂEEE
		switch (fpsDisp) {
			case 0 :
			case 1 :
				if (gui.core_ == gui.CORE_SOFTBANK) {
					g.drawScaledImage(img, 0, (w - 240) / 2, 240, 224, 8, 0, 240, 224);
				} else {
					g.drawScaledImage(img, 0, (w - 240) / 2, 240, 224, 0, 0, 256, 224);
				}
				//ʃTCYIɃX^bNKvȂ̂ŁA
				//  - ŉ[X^bN
				//  - ŉ[tB
				if (messageStr != null) {
					g.setColor(Graphics.getColorOfName(Graphics.BLACK));
					g.fillRect(0, (w - 240) / 2 + 224, h, 16);
					g.setColor(Graphics.getColorOfName(Graphics.WHITE));
					g.drawString(messageStr, 4, (w - 240) / 2 + 224 + BASE_LINE);
					messageStr = null;
				}
				break;
			case 2 :
				if (gui.core_ == gui.CORE_SOFTBANK) {
					g.drawScaledImage(img, 0, (w - 224) / 2, 224, 224, 8, 0, 240, 224);
				} else {
					g.drawScaledImage(img, 0, (w - 224) / 2, 224, 224, 0, 0, 256, 224);
				}
				//  - E[TCh
				if (messageStr != null) {
					StrImgG.setColor(Graphics.getColorOfName(Graphics.BLACK));
					StrImgG.fillRect(0, 0, w, 16);
					StrImgG.setColor(Graphics.getColorOfName(Graphics.WHITE));
					StrImgG.drawString(messageStr, w / 2 - 108, BASE_LINE);
					g.setFlipMode(Graphics.FLIP_ROTATE_LEFT);
					g.drawImage(StrImg, h - 16, 0, 0, 0, w, 16);
					messageStr = null;
				}
				break;
			default :
				if (gui.core_ == gui.CORE_SOFTBANK) {
					g.drawScaledImage(img, 0, (w - 240) / 2, 240, 224, 8, 0, 240, 224);
				} else {
					g.drawScaledImage(img, 0, (w - 240) / 2, 240, 224, 0, 0, 256, 224);
				}
				break;
		}
	}

	public void vrt_large(Graphics g, String messageStr, int fpsDisp){
	}

	public void vrt_wide(Graphics g, String messageStr, int fpsDisp){
		g.setFlipMode(Graphics.FLIP_NONE);
		switch (fpsDisp) {
			case 0 :
				BaseImg2G.setColor(Graphics.getColorOfName(Graphics.BLACK));
				BaseImg2G.fillRect(0, 0, h, w);
				BaseImg2G.setFlipMode(Graphics.FLIP_NONE);
				if (gui.core_ == gui.CORE_SOFTBANK) {
					BaseImg2G.drawScaledImage(img, 0, (w - 320) / 2, 240, 320, 8, 0, 240, 224);
				} else {
					BaseImg2G.drawScaledImage(img, 0, (w - 320) / 2, 240, 320, 0, 0, 256, 224);
				}
				//  - ŉ[X^bN
				if (messageStr != null) {
					BaseImg2G.setColor(Graphics.getColorOfRGB(0x00, 0x00, 0x00, 0xAA));
					BaseImg2G.fillRect(0, (w - 320) / 2 + 304, h, 16);
					BaseImg2G.setColor(Graphics.getColorOfName(Graphics.WHITE));
					BaseImg2G.drawString(messageStr, 4, (w - 320) / 2 + 304 + BASE_LINE);
					messageStr = null;
				}
				g.drawImage(BaseImg2, 0, 0);
				break;
			case 1 :
				if (gui.core_ == gui.CORE_SOFTBANK) {
					g.drawScaledImage(img, 0, (w - 320) / 2, 240, 304, 8, 0, 240, 224);
				} else {
					g.drawScaledImage(img, 0, (w - 320) / 2, 240, 304, 0, 0, 256, 224);
				}
				//  - ŉ[tB
				if (messageStr != null) {
					g.setColor(Graphics.getColorOfName(Graphics.BLACK));
					g.fillRect(0, (w - 320) / 2 + 304, h, 16);
					g.setColor(Graphics.getColorOfName(Graphics.WHITE));
					g.drawString(messageStr, 4, (w - 320) / 2 + 304 + BASE_LINE);
					messageStr = null;
				}
				break;
			case 2 :
				if (gui.core_ == gui.CORE_SOFTBANK) {
					g.drawScaledImage(img, 0, (w - 320) / 2, 224, 320, 8, 0, 240, 224);
				} else {
					g.drawScaledImage(img, 0, (w - 320) / 2, 224, 320, 0, 0, 256, 224);
				}
				//  - E[TCh
				if (messageStr != null) {
					StrImgG.setColor(Graphics.getColorOfName(Graphics.BLACK));
					StrImgG.fillRect(0, 0, w, 16);
					StrImgG.setColor(Graphics.getColorOfName(Graphics.WHITE));
					StrImgG.drawString(messageStr, w / 2 - 156, BASE_LINE);
					g.setFlipMode(Graphics.FLIP_ROTATE_LEFT);
					g.drawImage(StrImg, h - 16, 0, 0, 0, w, 16);
					messageStr = null;
				}
				break;
			default :
				if (gui.core_ == gui.CORE_SOFTBANK) {
					g.drawScaledImage(img, 0, (w - 320) / 2, 240, 320, 8, 0, 240, 224);
				} else {
					g.drawScaledImage(img, 0, (w - 320) / 2, 240, 320, 0, 0, 256, 224);
				}
				break;
		}
	}

	public void vrt_full(Graphics g, String messageStr, int fpsDisp){
		g.setFlipMode(Graphics.FLIP_NONE);
		switch (fpsDisp) {
			case 0 :
				BaseImg2G.setColor(Graphics.getColorOfName(Graphics.BLACK));
				BaseImg2G.fillRect(0, 0, h, w);
				BaseImg2G.setFlipMode(Graphics.FLIP_NONE);
				if (gui.core_ == gui.CORE_SOFTBANK) {
					BaseImg2G.drawScaledImage(img, 0, 0, 240, w, 8, 0, 240, 224);
				} else {
					BaseImg2G.drawScaledImage(img, 0, 0, 240, w, 0, 0, 256, 224);
				}
				//  - ŉ[X^bN
				if (messageStr != null) {
					BaseImg2G.setColor(Graphics.getColorOfRGB(0x00, 0x00, 0x00, 0xAA));
					BaseImg2G.fillRect(0, w - 16, h, 16);
					BaseImg2G.setColor(Graphics.getColorOfName(Graphics.WHITE));
					BaseImg2G.drawString(messageStr, 4, w - 16 + BASE_LINE);
					messageStr = null;
				}
				g.drawImage(BaseImg2, 0, 0);
				break;
			case 1 :
				if (gui.core_ == gui.CORE_SOFTBANK) {
					g.drawScaledImage(img, 0, 0, 240, w - 16, 8, 0, 240, 224);
				} else {
					g.drawScaledImage(img, 0, 0, 240, w - 16, 0, 0, 256, 224);
				}
				//  - ŉ[tB
				if (messageStr != null) {
					g.setColor(Graphics.getColorOfName(Graphics.BLACK));
					g.fillRect(0, w-16, h, 16);
					g.setColor(Graphics.getColorOfName(Graphics.WHITE));
					g.drawString(messageStr, 4, w-16 + BASE_LINE);
					messageStr = null;
				}
				break;
			case 2 :
				if (gui.core_ == gui.CORE_SOFTBANK) {
					g.drawScaledImage(img, 0, 0, 224, w, 8, 0, 240, 224);
				} else {
					g.drawScaledImage(img, 0, 0, 224, w, 0, 0, 256, 224);
				}
				//  - E[TCh
				if (messageStr != null) {
					StrImgG.setColor(Graphics.getColorOfName(Graphics.BLACK));
					StrImgG.fillRect(0, 0, w, 16);
					StrImgG.setColor(Graphics.getColorOfName(Graphics.WHITE));
					StrImgG.drawString(messageStr, 4, BASE_LINE);
					g.setFlipMode(Graphics.FLIP_ROTATE_LEFT);
					g.drawImage(StrImg, h - 16, 0, 0, 0, w, 16);
					messageStr = null;
				}
				break;
			default :
				if (gui.core_ == gui.CORE_SOFTBANK) {
					g.drawScaledImage(img, 0, 0, 240, w, 8, 0, 240, 224);
				} else {
					g.drawScaledImage(img, 0, 0, 240, w, 0, 0, 256, 224);
				}
				break;
		}
	}

	public void vrt_free(Graphics g, int pos_x, int pos_y, int x, int y, String messageStr, int fpsDisp){
		g.setFlipMode(Graphics.FLIP_NONE);
		switch (fpsDisp) {
			case 0 :
				BaseImg2G.setColor(Graphics.getColorOfName(Graphics.BLACK));
				BaseImg2G.fillRect(0, 0, h, w);
				BaseImg2G.setFlipMode(Graphics.FLIP_NONE);
				if (gui.core_ == gui.CORE_SOFTBANK) {
					BaseImg2G.drawScaledImage(img, pos_x, pos_y, x, y, 8, 0, 240, 224);
				} else {
					BaseImg2G.drawScaledImage(img, pos_x, pos_y, x, y, 0, 0, 256, 224);
				}
				//  - ŉ[X^bN
				if (messageStr != null) {
					BaseImg2G.setColor(Graphics.getColorOfRGB(0x00, 0x00, 0x00, 0xAA));
					BaseImg2G.fillRect(0, pos_y + y-16, h, 16);
					BaseImg2G.setColor(Graphics.getColorOfName(Graphics.WHITE));
					BaseImg2G.drawString(messageStr, pos_x + 4, pos_y + y-16 + BASE_LINE);
					messageStr = null;
				}
				g.drawImage(BaseImg2, 0, 0);
				break;
			case 1 :
				if (gui.core_ == gui.CORE_SOFTBANK) {
					g.drawScaledImage(img, pos_x, pos_y, x, y-16, 8, 0, 240, 224);
				} else {
					g.drawScaledImage(img, pos_x, pos_y, x, y-16, 0, 0, 256, 224);
				}
				//  - ŉ[tB
				//Yɍ킹ăbZ[W\ʒuB
				if (messageStr != null) {
					g.setColor(Graphics.getColorOfName(Graphics.BLACK));
					g.fillRect(0, pos_y + y-16, h, 16);
					g.setColor(Graphics.getColorOfName(Graphics.WHITE));
					g.drawString(messageStr, pos_x + 4, pos_y + y-16 + BASE_LINE);
					messageStr = null;
				}
				break;
			case 2 :
				if (gui.core_ == gui.CORE_SOFTBANK) {
					g.drawScaledImage(img, pos_x, pos_y, x-16, y, 8, 0, 240, 224);
				} else {
					g.drawScaledImage(img, pos_x, pos_y, x-16, y, 0, 0, 256, 224);
				}
				//  - E[TCh
				if (messageStr != null) {
					StrImgG.setColor(Graphics.getColorOfName(Graphics.BLACK));
					StrImgG.fillRect(0, 0, w, 16);
					StrImgG.setColor(Graphics.getColorOfName(Graphics.WHITE));
					StrImgG.drawString(messageStr, w - pos_y - y + 4, BASE_LINE);
					g.setFlipMode(Graphics.FLIP_ROTATE_LEFT);
					g.drawImage(StrImg, pos_x + x - 16, 0, 0, 0, w, 16);
					messageStr = null;
				}
				break;
			default :
				if (gui.core_ == gui.CORE_SOFTBANK) {
					g.drawScaledImage(img, pos_x, pos_y, x, y, 8, 0, 240, 224);
				} else {
					g.drawScaledImage(img, pos_x, pos_y, x, y, 0, 0, 256, 224);
				}
				break;
		}
	}

	public void hrz(Graphics g, String messageStr, int fpsDisp){
		BaseImgG.setColor(Graphics.getColorOfName(Graphics.BLACK));
		BaseImgG.fillRect(0, 0, w, h);
		BaseImgG.setFlipMode(Graphics.FLIP_NONE);
		if (gui.core_ == gui.CORE_SOFTBANK) {
			BaseImgG.drawImage(img, (w - 240) / 2, (h - 240) / 2, 8, 0, 240, 224);
		} else {
			BaseImgG.drawImage(img, (w - 240) / 2, (h - 240) / 2, 0, 0, 256, 224);
		}
		switch (fpsDisp) {
			case 0 :
			case 1 :
				//  - ŉ[
				if (messageStr != null) {
					BaseImgG.setColor(Graphics.getColorOfName(Graphics.BLACK));
					BaseImgG.fillRect(0, (h - 240) / 2 + 224, w, 16);
					BaseImgG.setColor(Graphics.getColorOfName(Graphics.WHITE));
					BaseImgG.drawString(messageStr, (w - 240) / 2 + 4, (h - 240) / 2 + 224 + BASE_LINE);
					messageStr = null;
				}
				break;
			case 2 :
				//  - E[
				if (messageStr != null) {
					StrImgG.setColor(Graphics.getColorOfName(Graphics.BLACK));
					StrImgG.fillRect(0, 0, h, 16);
					StrImgG.setColor(Graphics.getColorOfName(Graphics.WHITE));
					StrImgG.drawString(messageStr, (h - 240) / 2 + 20, BASE_LINE);
					BaseImgG.setFlipMode(Graphics.FLIP_ROTATE_LEFT);
					BaseImgG.drawImage(StrImg, (w - 240) / 2 + 224, 0, 0, 0, h, 16);
					messageStr = null;
				}
				break;
			default :
				break;
		}
		g.setFlipMode(Graphics.FLIP_ROTATE_RIGHT);
		g.drawImage(BaseImg, 0, 0);
	}

	public void hrz_large(Graphics g, String messageStr, int fpsDisp){
	}

	public void hrz_wide(Graphics g, String messageStr, int fpsDisp){
		BaseImgG.setColor(Graphics.getColorOfName(Graphics.BLACK));
		BaseImgG.fillRect(0, 0, w, h);
		BaseImgG.setFlipMode(Graphics.FLIP_NONE);
		switch (fpsDisp) {
			case 0 :
				if (gui.core_ == gui.CORE_SOFTBANK) {
					BaseImgG.drawScaledImage(img, (w - 320) / 2, (h - 240) / 2, 320, 240, 8, 0, 240, 224);
				} else {
					BaseImgG.drawScaledImage(img, (w - 320) / 2, (h - 240) / 2, 320, 240, 0, 0, 256, 224);
				}
				//  - ŉ[
				if (messageStr != null) {
					BaseImgG.setColor(Graphics.getColorOfRGB(0x00, 0x00, 0x00, 0xAA));
					BaseImgG.fillRect(0, (h - 240) / 2 + 224, w, 16);
					BaseImgG.setColor(Graphics.getColorOfName(Graphics.WHITE));
					BaseImgG.drawString(messageStr, (w - 320) / 2 + 4, (h - 240) / 2 + 224 + BASE_LINE);
					messageStr = null;
				}
				break;
			case 1 :
				if (gui.core_ == gui.CORE_SOFTBANK) {
					BaseImgG.drawScaledImage(img, (w - 320) / 2, (h - 240) / 2, 320, 224, 8, 0, 240, 224);
				} else {
					BaseImgG.drawScaledImage(img, (w - 320) / 2, (h - 240) / 2, 320, 224, 0, 0, 256, 224);
				}
				//  - ŉ[
				if (messageStr != null) {
					BaseImgG.setColor(Graphics.getColorOfName(Graphics.BLACK));
					BaseImgG.fillRect(0, (h - 240) / 2 + 224, w, 16);
					BaseImgG.setColor(Graphics.getColorOfName(Graphics.WHITE));
					BaseImgG.drawString(messageStr, (w - 320) / 2 + 4, (h - 240) / 2 + 224 + BASE_LINE);
					messageStr = null;
				}
				break;
			case 2 :
				if (gui.core_ == gui.CORE_SOFTBANK) {
					BaseImgG.drawScaledImage(img, (w - 320) / 2, (h - 240) / 2, 304, 240, 8, 0, 240, 224);
				} else {
					BaseImgG.drawScaledImage(img, (w - 320) / 2, (h - 240) / 2, 304, 240, 0, 0, 256, 224);
				}
				//  - E[
				if (messageStr != null) {
					StrImgG.setColor(Graphics.getColorOfName(Graphics.BLACK));
					StrImgG.fillRect(0, 0, h, 16);
					StrImgG.setColor(Graphics.getColorOfName(Graphics.WHITE));
					StrImgG.drawString(messageStr, 4, BASE_LINE);
					BaseImgG.setFlipMode(Graphics.FLIP_ROTATE_LEFT);
					BaseImgG.drawImage(StrImg, (w - 320) / 2 + 304, 0, 0, 0, h, 16);
					messageStr = null;
				}
				break;
			default :
				if (gui.core_ == gui.CORE_SOFTBANK) {
					BaseImgG.drawScaledImage(img, (w - 320) / 2, (h - 240) / 2, 320, 240, 8, 0, 240, 224);
				} else {
					BaseImgG.drawScaledImage(img, (w - 320) / 2, (h - 240) / 2, 320, 240, 0, 0, 256, 224);
				}
				break;
		}
		g.setFlipMode(Graphics.FLIP_ROTATE_RIGHT);
		g.drawImage(BaseImg, 0, 0);
	}

	public void hrz_full(Graphics g, String messageStr, int fpsDisp){
		BaseImgG.setColor(Graphics.getColorOfName(Graphics.BLACK));
		BaseImgG.fillRect(0, 0, w, h);
		BaseImgG.setFlipMode(Graphics.FLIP_NONE);
		switch (fpsDisp) {
			case 0 :
				if (gui.core_ == gui.CORE_SOFTBANK) {
					BaseImgG.drawScaledImage(img, 0, 0, w, h, 8, 0, 240, 224);
				} else {
					BaseImgG.drawScaledImage(img, 0, 0, w, h, 0, 0, 256, 224);
				}
				//  - ŉ[
				if (messageStr != null) {
					BaseImgG.setColor(Graphics.getColorOfRGB(0x00, 0x00, 0x00, 0xAA));
					BaseImgG.fillRect(0, 224, w, 16);
					BaseImgG.setColor(Graphics.getColorOfName(Graphics.WHITE));
					BaseImgG.drawString(messageStr, 4, 224 + BASE_LINE);
					messageStr = null;
				}
				break;
			case 1 :
				if (gui.core_ == gui.CORE_SOFTBANK) {
					BaseImgG.drawScaledImage(img, 0, 0, w, h - 16, 8, 0, 240, 224);
				} else {
					BaseImgG.drawScaledImage(img, 0, 0, w, h - 16, 0, 0, 256, 224);
				}
				//  - ŉ[
				if (messageStr != null) {
					BaseImgG.setColor(Graphics.getColorOfName(Graphics.BLACK));
					BaseImgG.fillRect(0, 224, w, 16);
					BaseImgG.setColor(Graphics.getColorOfName(Graphics.WHITE));
					BaseImgG.drawString(messageStr, 4, 224 + BASE_LINE);
					messageStr = null;
				}
				break;
			case 2 :
				if (gui.core_ == gui.CORE_SOFTBANK) {
					BaseImgG.drawScaledImage(img, 0, 0, w - 16, h, 8, 0, 240, 224);
				} else {
					BaseImgG.drawScaledImage(img, 0, 0, w - 16, h, 0, 0, 256, 224);
				}
				//  - E[
				if (messageStr != null) {
					StrImgG.setColor(Graphics.getColorOfName(Graphics.BLACK));
					StrImgG.fillRect(0, 0, h, 16);
					StrImgG.setColor(Graphics.getColorOfName(Graphics.WHITE));
					StrImgG.drawString(messageStr, 4, BASE_LINE);
					BaseImgG.setFlipMode(Graphics.FLIP_ROTATE_LEFT);
					BaseImgG.drawImage(StrImg, w - 16, 0, 0, 0, h, 16);
					messageStr = null;
				}
				break;
			default :
				if (gui.core_ == gui.CORE_SOFTBANK) {
					BaseImgG.drawScaledImage(img, 0, 0, w, h, 8, 0, 240, 224);
				} else {
					BaseImgG.drawScaledImage(img, 0, 0, w, h, 0, 0, 256, 224);
				}
				break;
		}
		g.setFlipMode(Graphics.FLIP_ROTATE_RIGHT);
		g.drawImage(BaseImg, 0, 0);
	}

	public void hrz_free(Graphics g, int pos_x, int pos_y, int x, int y, String messageStr, int fpsDisp){
		BaseImgG.setColor(Graphics.getColorOfName(Graphics.BLACK));
		BaseImgG.fillRect(0, 0, w, h);
		BaseImgG.setFlipMode(Graphics.FLIP_NONE);
		switch (fpsDisp) {
			case 0 :
				if (gui.core_ == gui.CORE_SOFTBANK) {
					BaseImgG.drawScaledImage(img, pos_x, pos_y, x, y, 8, 0, 240, 224);
				} else {
					BaseImgG.drawScaledImage(img, pos_x, pos_y, x, y, 0, 0, 256, 224);
				}
				//  - ŉ[X^bN
				if (messageStr != null) {
					BaseImgG.setColor(Graphics.getColorOfRGB(0x00, 0x00, 0x00, 0xAA));
					BaseImgG.fillRect(0, pos_y + y-16, w, 16);
					BaseImgG.setColor(Graphics.getColorOfName(Graphics.WHITE));
					BaseImgG.drawString(messageStr, pos_x + 4, pos_y + y-16 + BASE_LINE);
					messageStr = null;
				}
				break;
			case 1 :
				if (gui.core_ == gui.CORE_SOFTBANK) {
					BaseImgG.drawScaledImage(img, pos_x, pos_y, x, y-16, 8, 0, 240, 224);
				} else {
					BaseImgG.drawScaledImage(img, pos_x, pos_y, x, y-16, 0, 0, 256, 224);
				}
				//  - ŉ[tB
				//Yɍ킹ăbZ[W\ʒuB
				if (messageStr != null) {
					BaseImgG.setColor(Graphics.getColorOfName(Graphics.BLACK));
					BaseImgG.fillRect(0, pos_y + y-16, w, 16);
					BaseImgG.setColor(Graphics.getColorOfName(Graphics.WHITE));
					BaseImgG.drawString(messageStr, pos_x + 4, pos_y + y-16 + BASE_LINE);
					messageStr = null;
				}
				break;
			case 2 :
				if (gui.core_ == gui.CORE_SOFTBANK) {
					BaseImgG.drawScaledImage(img, pos_x, pos_y, x-16, y, 8, 0, 240, 224);
				} else {
					BaseImgG.drawScaledImage(img, pos_x, pos_y, x-16, y, 0, 0, 256, 224);
				}
				//  - E[TCh
				if (messageStr != null) {
					StrImgG.setColor(Graphics.getColorOfName(Graphics.BLACK));
					StrImgG.fillRect(0, 0, h, 16);
					StrImgG.setColor(Graphics.getColorOfName(Graphics.WHITE));
					StrImgG.drawString(messageStr, h - pos_y - y + 4, BASE_LINE);
					BaseImgG.setFlipMode(Graphics.FLIP_ROTATE_LEFT);
					BaseImgG.drawImage(StrImg, pos_x + x - 16, 0, 0, 0, h, 16);
					messageStr = null;
				}
				break;
			default :
				if (gui.core_ == gui.CORE_SOFTBANK) {
					BaseImgG.drawScaledImage(img, pos_x, pos_y, x, y, 8, 0, 240, 224);
				} else {
					BaseImgG.drawScaledImage(img, pos_x, pos_y, x, y, 0, 0, 256, 224);
				}
				break;
		}
		g.setFlipMode(Graphics.FLIP_ROTATE_RIGHT);
		g.drawImage(BaseImg, 0, 0);
	}

	public void drawString(Graphics g, int bgcolor, int fontcolor, String str, int x, int y){
		int width = Font.getDefaultFont().stringWidth(str);
		int height = Font.getDefaultFont().getHeight();
		Image img = Image.createImage(width, height);
		Graphics imgG = img.getGraphics();

		imgG.setFont(Font.getDefaultFont());
		imgG.setColor(bgcolor);
		imgG.fillRect(0, 0, width, height);
		imgG.setColor(fontcolor);
		imgG.drawString(str, 0, Font.getDefaultFont().getAscent());
		g.setFlipMode(Graphics.FLIP_ROTATE_RIGHT);
		g.drawImage(img, (h - y - Font.getDefaultFont().getAscent()), x);
	}

	public void drawString2(Graphics g, int bgcolor, int fontcolor, String str, int x, int y){
		int width = Font.getDefaultFont().stringWidth(str);
		int height = Font.getDefaultFont().getHeight();
		Image img = Image.createImage(width, height);
		Graphics imgG = img.getGraphics();

		imgG.setFont(Font.getDefaultFont());
		imgG.setColor(bgcolor);
		imgG.fillRect(0, 0, width, height);
		imgG.setColor(fontcolor);
		imgG.drawString(str, 0, Font.getDefaultFont().getAscent());
		g.setFlipMode(Graphics.FLIP_NONE);
		g.drawImage(img, x, y);
	}
}
