public final class Mapper097 extends Mapper {



    public Mapper097(NESCore nes) {
        super(nes);

    }

    /////////////////////////////////////////////////////////////////////
    // Mapper 97
    public final void Reset() {
	  // set CPU bank pointers
	  set_CPU_banks(num_8k_ROM_banks-2,num_8k_ROM_banks-1,0,1);

	  // set PPU bank pointers ?
	  if(num_1k_VROM_banks!=0)
	  {
	    set_PPU_banks(0,1,2,3,4,5,6,7);
	  }
    }

    public final void MemoryWrite(int addr, int data) {
	  if(addr < 0xC000)
	  {
	    int prg_bank = data & 0x0F;

	    set_CPU_bank6(prg_bank*2+0);
	    set_CPU_bank7(prg_bank*2+1);

	    if((data & 0x80) == 0)
	    {
	      set_mirroring(NESCore.MIRROR_HORIZ);
	    }
	    else
	    {
	      set_mirroring(NESCore.MIRROR_VERT);
	    }
	  }
    }

    /////////////////////////////////////////////////////////////////////

}
